package de.lessvoid.nifty.effects.hover;

import java.util.Properties;

import de.lessvoid.nifty.Nifty;
import de.lessvoid.nifty.elements.Element;
import de.lessvoid.nifty.render.NiftyRenderEngine;
import de.lessvoid.nifty.render.spi.RenderFont;

/**
 * ChangeFont.
 * @author void
 */
public class ChangeFont implements HoverEffectImpl {

  /**
   * changed font.
   */
  private RenderFont font;

  /**
   * initialize.
   * @param nifty Nifty
   * @param element Element
   * @param parameter Parameter
   */
  public void initialize(final Nifty nifty, final Element element, final Properties parameter) {
    font = nifty.getRenderDevice().createFont(parameter.getProperty("font"));
  }

  /**
   * execute the effect.
   * @param element the Element
   * @param normalizedTime TimeInterpolator to use
   * @param normalizedFalloff falloff value
   * @param r RenderDevice to use
   */
  public void execute(
      final Element element,
      final float normalizedTime,
      final float normalizedFalloff,
      final NiftyRenderEngine r) {
    r.setFont(font);
  }

  /**
   * deactivate the effect.
   */
  public void deactivate() {
  }
}
